"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEventCancer(ProtocolElement):
    """
    A report event holds all the information about why a given variant is
    relevant to report. This is the report event     corresponding to
    the cancer program
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "genomicEntities",
        "reportEventId",
        "variantConsequences",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "actions": reports_5_0_0.Action,
            "genomicEntities": reports_5_0_0.GenomicEntity,
            "variantClassification": reports_5_0_0.VariantClassification,
            "variantConsequences": reports_5_0_0.VariantConsequence,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "roleInCancer": reports_5_0_0.RoleInCancer,
            "tier": reports_5_0_0.Tier,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.Action": reports_5_0_0.Action,
            "org.gel.models.report.avro.GenomicEntity": reports_5_0_0.GenomicEntity,
            "org.gel.models.report.avro.RoleInCancer": reports_5_0_0.RoleInCancer,
            "org.gel.models.report.avro.Tier": reports_5_0_0.Tier,
            "org.gel.models.report.avro.VariantClassification": reports_5_0_0.VariantClassification,
            "org.gel.models.report.avro.VariantConsequence": reports_5_0_0.VariantConsequence,
            "org.gel.models.report.avro.ReportEventCancer": reports_5_0_0.ReportEventCancer,
        }

    __slots__ = [
        "genomicEntities",
        "reportEventId",
        "variantConsequences",
        "actions",
        "eventJustification",
        "groupOfVariants",
        "roleInCancer",
        "score",
        "tier",
        "variantClassification",
        "vendorSpecificScores",
    ]

    def __init__(
        self,
        genomicEntities,
        reportEventId,
        variantConsequences,
        actions=None,
        eventJustification=None,
        groupOfVariants=None,
        roleInCancer=None,
        score=None,
        tier=None,
        variantClassification=None,
        vendorSpecificScores=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.ReportEventCancer model.

        :param genomicEntities:
            The list of genomic features of interest for this report event. Please
            note that one variant can overlap more         that one
            gene/transcript. If more than one gene/transcript is
            considered interesting for this particular
            variant, should be reported in two different ReportEvents
        :type genomicEntities: list[GenomicEntity]
        :param reportEventId:
            Unique identifier for each report event, this is unique across the
            whole report. A report having more than one         report
            event with the same identifier is invalid. Repeating
            report event identifiers between different reports
            is valid. The uniqueness of this field will be checked in
            report validation
        :type reportEventId: str
        :param variantConsequences:
            Sequence Ontology terms for relevant consequence types in tiering
        :type variantConsequences: list[VariantConsequence]
        :param actions:
            Actions on the variant
        :type actions: None | list[Action]
        :param eventJustification:
            This is the description of why this variant would be reported, for
            example that it affects the protein in this way
            and that this gene has been implicated in this disorder in
            these publications. Publications should be provided as
            PMIDs         using the format [PMID:8075643]. Other
            sources can be used in the same manner, e.g.
            [OMIM:163500]. Brackets need to be included.
        :type eventJustification: None | str
        :param groupOfVariants:
            This value groups variants that together could explain the phenotype
            according to the mode of inheritance used.         (e.g.:
            compound heterozygous). All the variants in the same
            report sharing the same value will be considered in
            the same group (i.e.: reported together). This value is an
            integer unique in the whole report.         These values
            are only relevant within the same report.
        :type groupOfVariants: None | int
        :param roleInCancer:
            The role of this variant in cancer
        :type roleInCancer: None | list[RoleInCancer]
        :param score:
            This is the score provided to reflect a variant's likelihood of
            explaining the phenotype using a specific         mode of
            Inheritance. This may be the result of different scoring
            systems
        :type score: None | float
        :param tier:
            The tier where this variant has been classified. Tier is a property of
            the model of inheritance and therefore         is subject
            to change depending on the inheritance assumptions
        :type tier: None | Tier
        :param variantClassification:
            Variant classification
        :type variantClassification: None | VariantClassification
        :param vendorSpecificScores:
            Other scores that the interpretation provider may add (for example
            phenotypically informed or family         informed scores)
        :type vendorSpecificScores: None | dict[str, float]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
